# ---------------------------------------------------------------------
# Copyright (c) 1996 Christian Krone. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Tcl itself.
# See also licence.terms
# ----------------------------------------------------------------------------

# ---------------------------------------------------------------------
# First and all we need the AdabasTcl extension.
# ---------------------------------------------------------------------
proc loadAdabastcl {} {
    global env auto_path

    if {![info exists env(DBROOT)]} {
	append err "This application is only functional, if the environment "
	append err "variable DBROOT is set correctly."

	tk_dialog .err "Fatal error" $err questhead 0 Exit  
        exit 1
    }

    lappend auto_path $env(DBROOT)/lib $env(DBROOT)/tcl

    if {[catch {package require Adabastcl} msg]} {
	append err "This application is only functional with the Adabastcl "
	append err "extension. While starting it, the following error occurs:"
	append err "\n\n$msg\n\n"
	append err "You must have set DBROOT correctly and you have to install "
	append err "the extension by using the make install command in the "
	append err "directory adabastcl-0.5/adabastcl."

	tk_dialog .err "Fatal error" $err questhead 0 Exit  
        exit 2
    }

    # Just to be sure, that the extension is loaded. "package require" does
    # not actually load the shared library, but adds the commands only to the
    # list of the unknown procedures; this applies not to variables - and we
    # will need adabastcl_library more or less immediately.
    adabas version
}

# ---------------------------------------------------------------------
# Now we have to do some limbo to get TclTk's version clear.
# ---------------------------------------------------------------------

# 1. The argument of the -weight option of the grid command changed
#    from float into an integer.
if {$tk_version >= 4.2} {
    set GRID_WEIGHT(MAX)  100
    set GRID_WEIGHT(MIN)  0
} else {
    set GRID_WEIGHT(MAX)  1.0
    set GRID_WEIGHT(MIN)  0.0
}

# 2. This should be set to 1, if we are running as plugin or have a
#    Tk version, that is capable of reading gif out of the -data option.
set imageViaData [expr $tk_version >= 4.4 || [info exists embed_args]]

